﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace TreeViewLonDemand
{
    public class DataItem : INotifyPropertyChanged
    {

        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
        }

        private bool loadOnDemand;
        public bool LoadOnDemand
        {
            get { return loadOnDemand; }
            set
            {
                loadOnDemand = value;
                RaisePropertyChanged("LoadOnDemand");
            }
        }


        private string name;
        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                RaisePropertyChanged("Name");
            }
        }

        private bool expanded;
        public bool Expanded
        {
            get { return expanded; }
            set
            {
                expanded = value;
                RaisePropertyChanged("Expanded");
            }
        }

        public ObservableCollection<DataItem> Children
        {
            get;
            set;
        }

        public event PropertyChangedEventHandler PropertyChanged;

				protected void RaisePropertyChanged(string propertyName)
				{
					var handler = PropertyChanged;
					if(handler != null)
					{
						handler(this, new PropertyChangedEventArgs(propertyName));
					}
				}        

    }
}
